#ifndef STOCK_H

#define STOCK_H

#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>

#define BUY  1
#define SELL 2

typedef int32_t plid_t;
typedef int32_t cid_t; 
typedef int32_t grid_t;
typedef u_int32_t pr_t;
typedef int32_t qty_t;
typedef unsigned char req_t;
typedef int32_t slot_t;
typedef int32_t passwd_t;
typedef u_int32_t cash_t;

#define PORTNUM 5000
#define HASHSIZE 5
#define UPDATE_INTERVAL 1
#define TOLERANCE 5

#include "services.h"
#include "socket.h"
#include "players.h"
#include "companies.h"

#define MALLOC_CHECK_ 2
/* socket.c */
void sock_read (int socket, void *buf, int cnt);
void sock_write (int socket, void *buf, int cnt);
inline void sw_s_int (int socket, int16_t s);
inline void sw_int (int socket, int32_t i);
char *sock_read_string (int socket);

/* client.c */
void quote (int a, int b, int c, int d);
void get_comp_names ();
void get_comp_misc ();
void update_new_buy (cid_t, qty_t);
void update_new_sell (cid_t, qty_t);
void display_results (char *s1, cid_t cid, char *s3, char *s4);
void get_comp_list (cid_t cid, int call);

/* ui.c */
void update_result_area (char *s[]);
void update_buy_list (char *);
void get_comp_last_trade (cid_t cid);
void update_cash ();
void quit ();
void update_result_area (char *s[]);

#endif /* STOCK_H */
